//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "UMainForm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "msDBTreeView"
#pragma resource "*.dfm"
TMainForm *MainForm;

//---------------------------------------------------------------------------
void __fastcall TMainForm::Open_Connection(const int Value)
{
  ID_Lang = Value;

  if (ADODataSet->Active)
  {
    msDBTreeView->Close();
    ADODataSet->Close();
  }

  const String ConnStr      = "Provider=%s;Data Provider=%s;Data Source=%s";
  const String Provider     = "MSDataShape.1";
  const String DataProvider = "Microsoft.Jet.OLEDB.4.0";
  const String DataSource   = ExtractFilePath(Application->ExeName) + "DB.mdb";
  ADODataSet->ConnectionString = Format(ConnStr, ARRAYOFCONST((Provider, DataProvider, DataSource)));
  if (!ID_Lang)
    ADODataSet->CommandText = "English";
  else
    ADODataSet->CommandText = "Russian";

  ADODataSet->Open();
  msDBTreeView->Open();
}

//---------------------------------------------------------------------------
void __fastcall TMainForm::SwitchLanguage(const int ID)
{
  if (!ID)
  {
    MMenu_File->Caption             = "File";
    Action_FileOpen->Caption        = "Open";
    Action_FileClose->Caption       = "Close";
    Action_FileExit->Caption        = "Exit";
    MMenu_Edit->Caption             = "Edit";
    Action_EditAddFile->Caption     = "Add File";
    Action_EditAddFolder->Caption   = "Add Folder";
    Action_EditDelNode->Caption     = "Delete Node";
    MMenu_Language->Caption         = "Language";
    Action_LanguageEnglish->Caption = "English";
    Action_LanguageRussian->Caption = "Russian";
  }
  else
  {
    MMenu_File->Caption             = "";
    Action_FileOpen->Caption        = "";
    Action_FileClose->Caption       = "";
    Action_FileExit->Caption        = "";
    MMenu_Edit->Caption             = "";
    Action_EditAddFile->Caption     = " ";
    Action_EditAddFolder->Caption   = " ";
    Action_EditDelNode->Caption     = " ";
    MMenu_Language->Caption         = "";
    Action_LanguageEnglish->Caption = "";
    Action_LanguageRussian->Caption = "";
  }
}

//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
  : TForm(Owner)
{                                             
}

//---------------------------------------------------------------------------
void __fastcall TMainForm::FormCreate(TObject *Sender)
{
  Open_Connection(0);
  WindowState = wsMaximized;
}

//---------------------------------------------------------------------------
void __fastcall TMainForm::msDBTreeViewBeforeAddNode(TObject *Sender,
      int _type, bool &Confirm)
{
  AnsiString Msg = RES_STR_MSG[_type][ID_Lang];
  Confirm = (MessageDlg(Msg, mtConfirmation, TMsgDlgButtons() << mbYes << mbNo, 0) == mrYes);
}

//---------------------------------------------------------------------------
void __fastcall TMainForm::msDBTreeViewBeforeDelNode(TObject *Sender,
      int _type, bool &Confirm)
{
  AnsiString Msg = RES_STR_MSG[_type + 2][ID_Lang];
  Confirm = (MessageDlg(Msg, mtConfirmation, TMsgDlgButtons() << mbYes << mbNo, 0) == mrYes);
}

//---------------------------------------------------------------------------
void __fastcall TMainForm::msDBTreeViewSelectNode(TObject *Sender,
      TTreeNode *Node)
{
  switch (msDBTreeView->TypeOfSelected)
  {
    case FOLDER_TypeOfNode :
      DBRichEdit->Color = clSilver;
      StatusBar->Panels->Items[0]->Text = RES_STR_MSG[4][ID_Lang];
    break;
    case RECORD_TypeOfNode :
      DBRichEdit->Color = clWhite;
      StatusBar->Panels->Items[0]->Text = RES_STR_MSG[5][ID_Lang];
    break;
  }
}

//---------------------------------------------------------------------------
void __fastcall TMainForm::Action_FileOpenExecute(TObject *Sender)
{
  msDBTreeView->Open();
}

//---------------------------------------------------------------------------
void __fastcall TMainForm::Action_FileCloseExecute(TObject *Sender)
{
  msDBTreeView->Close();
}

//---------------------------------------------------------------------------
void __fastcall TMainForm::Action_FileExitExecute(TObject *Sender)
{
  Close();
}

//---------------------------------------------------------------------------
void __fastcall TMainForm::Action_EditAddFileExecute(TObject *Sender)
{
  msDBTreeView->AddNode(RECORD_TypeOfNode);
}

//---------------------------------------------------------------------------
void __fastcall TMainForm::Action_EditAddFolderExecute(TObject *Sender)
{
  msDBTreeView->AddNode(FOLDER_TypeOfNode);
}

//---------------------------------------------------------------------------
void __fastcall TMainForm::Action_EditDelNodeExecute(TObject *Sender)
{
  msDBTreeView->DelNode();
}

//---------------------------------------------------------------------------
void __fastcall TMainForm::Action_LanguageEnglishExecute(TObject *Sender)
{
  SwitchLanguage(0);
  Open_Connection(0);
}

//---------------------------------------------------------------------------
void __fastcall TMainForm::Action_LanguageRussianExecute(TObject *Sender)
{
  SwitchLanguage(1);
  Open_Connection(1);
}

//---------------------------------------------------------------------------

